# coding: utf-8

"""
    Collibra Data Governance Center Core API

    <p>The Core REST API allows you to create your own integrations with Collibra Data Governance Center.</p><p><i>Create custom applications to help users get access to the right data.</i></p>  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from collibra_core.api_client import ApiClient


class IssuesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_issue(self, **kwargs):  # noqa: E501
        """Adds a new issue.  # noqa: E501

        Adds a new issue with the given parameters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_issue(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AddIssueRequest body: The properties of the issue to be added
        :return: AssetImpl
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_issue_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.add_issue_with_http_info(**kwargs)  # noqa: E501
            return data

    def add_issue_with_http_info(self, **kwargs):  # noqa: E501
        """Adds a new issue.  # noqa: E501

        Adds a new issue with the given parameters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_issue_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AddIssueRequest body: The properties of the issue to be added
        :return: AssetImpl
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_issue" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/issues', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AssetImpl',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def find_issues(self, **kwargs):  # noqa: E501
        """Returns issues matching the given search criteria.  # noqa: E501

        Returns issues matching the given search criteria. Only parameters that are specified in this request and have not <code>null</code> values are used for filtering. All other parameters are ignored. The returned issues satisfy all constraints that are specified in this search criteria. By default a result containing 1000 issues is returned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.find_issues(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int offset: The first result to retrieve. If not set (offset = <code>0</code>), results will be retrieved starting from row <code>0</code>.
        :param int limit: The maximum number of results to retrieve. If not set (limit = <code>0</code>), the default limit will be used. The maximum allowed limit is 1000.
        :param int count_limit: Allows to limit the number of elements that will be counted. -1 will count everything and 0 will cause the count to be skipped
        :param str sort_order: The sorting order of the results.
        :param str sort_field: The field on which the results are sorted. Default is NAME.
        :param bool only_open_issues: Whether only open issues should be returned.
        :param str user_relation: The relation of the user with the issues to be returned. By default all issues for the current user will be returned.
        :return: AssetPagedResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.find_issues_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.find_issues_with_http_info(**kwargs)  # noqa: E501
            return data

    def find_issues_with_http_info(self, **kwargs):  # noqa: E501
        """Returns issues matching the given search criteria.  # noqa: E501

        Returns issues matching the given search criteria. Only parameters that are specified in this request and have not <code>null</code> values are used for filtering. All other parameters are ignored. The returned issues satisfy all constraints that are specified in this search criteria. By default a result containing 1000 issues is returned.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.find_issues_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int offset: The first result to retrieve. If not set (offset = <code>0</code>), results will be retrieved starting from row <code>0</code>.
        :param int limit: The maximum number of results to retrieve. If not set (limit = <code>0</code>), the default limit will be used. The maximum allowed limit is 1000.
        :param int count_limit: Allows to limit the number of elements that will be counted. -1 will count everything and 0 will cause the count to be skipped
        :param str sort_order: The sorting order of the results.
        :param str sort_field: The field on which the results are sorted. Default is NAME.
        :param bool only_open_issues: Whether only open issues should be returned.
        :param str user_relation: The relation of the user with the issues to be returned. By default all issues for the current user will be returned.
        :return: AssetPagedResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['offset', 'limit', 'count_limit', 'sort_order', 'sort_field', 'only_open_issues', 'user_relation']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method find_issues" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'offset' in params:
            query_params.append(('offset', params['offset']))  # noqa: E501
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501
        if 'count_limit' in params:
            query_params.append(('countLimit', params['count_limit']))  # noqa: E501
        if 'sort_order' in params:
            query_params.append(('sortOrder', params['sort_order']))  # noqa: E501
        if 'sort_field' in params:
            query_params.append(('sortField', params['sort_field']))  # noqa: E501
        if 'only_open_issues' in params:
            query_params.append(('onlyOpenIssues', params['only_open_issues']))  # noqa: E501
        if 'user_relation' in params:
            query_params.append(('userRelation', params['user_relation']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/issues', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AssetPagedResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def move_issue(self, issue_id, community_id, **kwargs):  # noqa: E501
        """Moves an issue to another community.  # noqa: E501

        Moves an issue to another community.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.move_issue(issue_id, community_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str issue_id: ID of the issue to be moved (required)
        :param str community_id: ID of the community to move the issue to (required)
        :return: AssetImpl
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.move_issue_with_http_info(issue_id, community_id, **kwargs)  # noqa: E501
        else:
            (data) = self.move_issue_with_http_info(issue_id, community_id, **kwargs)  # noqa: E501
            return data

    def move_issue_with_http_info(self, issue_id, community_id, **kwargs):  # noqa: E501
        """Moves an issue to another community.  # noqa: E501

        Moves an issue to another community.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.move_issue_with_http_info(issue_id, community_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str issue_id: ID of the issue to be moved (required)
        :param str community_id: ID of the community to move the issue to (required)
        :return: AssetImpl
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['issue_id', 'community_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method move_issue" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'issue_id' is set
        if ('issue_id' not in params or
                params['issue_id'] is None):
            raise ValueError("Missing the required parameter `issue_id` when calling `move_issue`")  # noqa: E501
        # verify the required parameter 'community_id' is set
        if ('community_id' not in params or
                params['community_id'] is None):
            raise ValueError("Missing the required parameter `community_id` when calling `move_issue`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'issue_id' in params:
            path_params['issueId'] = params['issue_id']  # noqa: E501
        if 'community_id' in params:
            path_params['communityId'] = params['community_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/issues/{issueId}/community/{communityId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AssetImpl',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
