# coding: utf-8

"""
    Collibra Data Governance Center Core API

    <p>The Core REST API allows you to create your own integrations with Collibra Data Governance Center.</p><p><i>Create custom applications to help users get access to the right data.</i></p>  # noqa: E501

    OpenAPI spec version: 2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DataQualityMetricRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'count_operation': 'str',
        'attribute_type_id': 'str'
    }

    attribute_map = {
        'count_operation': 'countOperation',
        'attribute_type_id': 'attributeTypeId'
    }

    def __init__(self, count_operation=None, attribute_type_id=None):  # noqa: E501
        """DataQualityMetricRequest - a model defined in Swagger"""  # noqa: E501
        self._count_operation = None
        self._attribute_type_id = None
        self.discriminator = None
        if count_operation is not None:
            self.count_operation = count_operation
        if attribute_type_id is not None:
            self.attribute_type_id = attribute_type_id

    @property
    def count_operation(self):
        """Gets the count_operation of this DataQualityMetricRequest.  # noqa: E501

        The operation that should be performed when aggregating the quality results.  # noqa: E501

        :return: The count_operation of this DataQualityMetricRequest.  # noqa: E501
        :rtype: str
        """
        return self._count_operation

    @count_operation.setter
    def count_operation(self, count_operation):
        """Sets the count_operation of this DataQualityMetricRequest.

        The operation that should be performed when aggregating the quality results.  # noqa: E501

        :param count_operation: The count_operation of this DataQualityMetricRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["Sum", "Minimum", "Maximum", "Average", "Median", "BooleanAnd", "BooleanOr"]  # noqa: E501
        if count_operation not in allowed_values:
            raise ValueError(
                "Invalid value for `count_operation` ({0}), must be one of {1}"  # noqa: E501
                .format(count_operation, allowed_values)
            )

        self._count_operation = count_operation

    @property
    def attribute_type_id(self):
        """Gets the attribute_type_id of this DataQualityMetricRequest.  # noqa: E501

        The ID of the attribute type that defines the value that is used as the data quality metric.  # noqa: E501

        :return: The attribute_type_id of this DataQualityMetricRequest.  # noqa: E501
        :rtype: str
        """
        return self._attribute_type_id

    @attribute_type_id.setter
    def attribute_type_id(self, attribute_type_id):
        """Sets the attribute_type_id of this DataQualityMetricRequest.

        The ID of the attribute type that defines the value that is used as the data quality metric.  # noqa: E501

        :param attribute_type_id: The attribute_type_id of this DataQualityMetricRequest.  # noqa: E501
        :type: str
        """

        self._attribute_type_id = attribute_type_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DataQualityMetricRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DataQualityMetricRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
